# Define the string to parse.
set logEntry {Mar 25 14:52:50 clif sendmail[23755]:
    from=<tcl-core-admin@lists.sourceforge.net>,
    size=35362, class=-60, nrcpts=1}
    
    # Extract "From" using string first and string range
    set openAnglePos [string first "<" $logEntry]
    set closeAnglePos [string first ">" $logEntry]
    set fromField [string range $logEntry $openAnglePos $closeAnglePos]
    
    # Extract the date using scan
    scan $logEntry {%s %d %d:%d} mon day hour minute
    # Extract the size using scan and string cmds.
    set sizeStart [string first "size=" $logEntry]
    set substring [string range $logEntry $sizeStart end]
    
    # The formatString looks for a word composed of the
    # letters*_eisz' (size will match) followed by an
    # equals sign, followed by an integer. The word
    #*_size' gets placed in the variable discard,
    # and the numeric value is placed in the variable
    # sizeField.
    scan $substring {%[eisz]=%d} discard sizeField
    
    puts [format {%-12s %-40s %-s} "Timestamp" "From" "Size"]
    puts [format {%s %d %d:%d %-40s %d} \
        $mon $day $hour $minute $fromField $sizeField]
    

