# List Commands Example

# Define the raw data

set rawData { Package,Major,Minor,Patch
    Tcl,8,6,0
    math::geometry,1,0,3
    math::complexnumbers,1,0,2}

# Split the raw data into a list using the newlines
#  as list element separators.
# This creates a list in which each line becomes a
#  list element

set dataList [split $rawData "\n"]

# Create a list of the column headers.

set columns [split [lindex $dataList 0] ","]

foreach line [lrange $dataList 1 end] {
    
    # Convert the line of data into a list
    
    set rowValues [split $line ","]\
            
    # Create a new list from $rowValues that includes
    
    # all the elements after the first (package name).
    
    set revList [lrange $rowValues 1 end]
    
    # and rejoin them into a "." separated string
    
    set revision [join $revList "."]
    
    # Display a reformatted version of the data line
    
    puts [format "%s: %s Revision: %s" [lindex $columns 0]\
        [lindex $rowValues 0] $revision]
    
}


