set x 7
set y 7
# Using no braces substitution occurs before the switch
# command looks for matches.
# Thus a variable can be used as a match pattern:

switch $x \
        $y      {puts "X=Y"} \
        {[0-9]} {puts "< 10"} \
        default {puts "> 10"}

# With braces, the $y is not substituted to 7, and switch looks
# for a match to the literal string $y

switch -glob $x {
    "1" {puts "one"}
    "2" {puts "two"}
    "3" {puts "three"}
    "$y" {puts "X=Y"}
    {[4-9]} {puts "greater than 3"}
    default {puts "Not a value between 1 and 9"}
}


